##############################################################################
## $Id: parsetester.py,v 1.2 2003/02/08 02:23:14 albro Exp $
##############################################################################
##                               parsetester.py
##
##              Copyright (C) 2003, UCLA.  All Rights Reserved.
##############################################################################
## Authors:
##      Daniel M. Albro
##############################################################################
## Description:
##      Automatic regression tester for parser.
##############################################################################
## History:
##      01/27/03 - [da]: Initial Creation.
##############################################################################
## Bugs:
##############################################################################
## To Do:
##############################################################################

import os
import sys
import string

def test_parse(grammar, sentence, positive):
    result = os.system("./botmcfg %s \"%s\" >> output.log" % \
                       (grammar, sentence))
    if positive and result != 0:
        print "Grammar \"%s\" should have accepted \"%s\" but didn't." % \
              (grammar, sentence)
    elif not positive and result == 0:
        print "Grammar \"%s\" should have rejected \"%s\" but didn't." % \
              (grammar, sentence)

def extension(str):
    idx = string.rfind(str, ".")
    if idx == -1:
        return ""
    return str[idx:]

def reextensioned(str, new_ext):
    idx = string.rfind(str, ".")
    if idx == -1:
        raise ValueError
    str = str[:idx] + new_ext
    return str

def test_examples(path, positive):
    grm = reextensioned(path, ".grm")
    f = open(path, "r")
    line = f.readline()
    while line:
        line = line[:-1]
        test_parse(grm, line, positive)
        line = f.readline()

def main():
    if len(sys.argv) < 2:
        print "Usage: %s <example-folder>+" % sys.argv[0]
        sys.exit(1)

    try:
        os.remove("output.log")
    except OSError:
        pass

    folders = sys.argv[1:]
    for folder in folders:
        paths = os.listdir(folder)
        paths = map(lambda x: os.path.join(folder, x), paths)
        pospaths = filter(lambda x: extension(x) == ".pos", paths)
        negpaths = filter(lambda x: extension(x) == ".neg", paths)
        for path in pospaths:
            test_examples(path, 1)
        for path in negpaths:
            test_examples(path, 0)

    print "Done.  A log may be available in the file \"output.log\"."

    return 0

if __name__ == '__main__':
    main()
    
            
            
        
        
