(* -*- mode: tuareg                                                        -*-
******************************************************************************
** $Id: botmcfg.mli,v 1.3 2003/02/25 02:37:35 albro Exp $
******************************************************************************
**                                botmcfg.mli
**
**              Copyright (C) 2002, UCLA.  All Rights Reserved.
*****************************************************************************)

(** Main module for the Bottom-Up MCFG Chart Parser.  Designed to efficiently
  parse {i n}-MCFGs of arbitrary dimension (arbitrary {i n}), with empty
  categories.  The MCFGs must be in a normal form where terminating rules
  must be of arity (dimension) 1, and non-terminating rules must have no
  more than two right hand side elements, which must be nonterminal symbols.
  In addition, the mapping functions for each production must mention each
  right-hand side element exactly once. 

  @author Daniel M. Albro
  @version $Revision: 1.3 $
  @since 10/24/02 - [da]: Initial Creation
*)

val bottom_up_parse : Grammar.grammar -> int array -> Chart.chart
  (** Parses [sentence] with respect to grammar [g].
    
    @param g - Grammar within which to parse
    @param sentence - an array of integers from the terminals symbol
    table of [g]
    @return the filled-out chart.
    @raise Success(ch) if parse succeeded.  Argument is the filled-out chart.
  *)

